! Program created by Gustavo Catao Alves at
! the Stanford Exploration Project
! May, 6th, 2014

! snapshot module
module snap_mod_new

  implicit none
  integer, private :: nx, nz
  real, dimension(:,:,:), pointer, private :: snapU, snapV

  contains

  ! Initialization of all variables needed by this subroutine
  subroutine snap_init(nz_in, nx_in, snapU_in, snapV_in)
    integer             :: nx_in, nz_in
    real, dimension(:,:,:), target :: snapU_in, snapV_in
    nx = nx_in
    nz = nz_in
    snapU => snapU_in
    snapV => snapV_in
  end subroutine

  ! Function that is called by elastic_mod
  function snap_op(countsnap, Vx, Vz) result(stat)
    integer,intent(in) :: countsnap
    real,dimension(:)  :: Vx, Vz
    integer            :: stat
    call snap_op2(countsnap,Vx, Vz)
    stat=0
  end function

  subroutine snap_op2(countsnap,Vx,Vz)
    integer,intent(in)      :: countsnap
    real,dimension(nz,nx) :: Vx,Vz
    integer                 :: ix,iz

    do ix=1,nx
      do iz=1,nz
        snapU(iz,ix,countsnap)=Vx(iz,ix)
        snapV(iz,ix,countsnap)=Vz(iz,ix)
      enddo
    enddo

  endsubroutine

endmodule

